#include <avr/io.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <util/delay.h>

#include "lcd.h"

//***********************************************************************************
// Deklarationen und Funktionsprototypen von:  **************************************
//***********************************************************************************


//*******************	adc.c	***********************************************		
//*****************************************************************************

extern uint8_t volatile button, button_1, button_2, temp_button;
extern uint16_t volatile equal_counter;
extern uint16_t volatile adc_value [];	/* Feld fr die Wandlungsergebnisse des ADC 
															= ADC-Ergebnis-Speicher */
extern uint8_t volatile adc_channel[];	// Kanalabfolge fr das Auslesen der ADC-Werte
extern uint8_t volatile adc_index;		// Index fr Kanalwahl und ADC-Speicher

void adc_init(void);



//******************	timer1	***********************************************
//*****************************************************************************
extern uint8_t volatile soft_prescaler;
extern uint8_t volatile time_puls;

//***********************
void timer1_init(void);



//*****************	unterprogramme.c	*************************************
//***************************************************************************

extern int8_t second_countdown;				// Variablen fr Countdown
extern int8_t hour_countdown;
extern int8_t minute_countdown;				

//**********************
uint16_t adc_read_avg (uint8_t channel , uint8_t average);
void read_voltage_source(void);
void read_voltage_electrodes(void);
void read_current_electrodes(void);
uint8_t read_LUT(uint16_t adc_val_button);
void my_ultoa(uint32_t zahl, char* string);
void round_32bit (char* string , uint8_t index_digit);
void print_lcd_uint(char* string,uint8_t index_start,uint8_t index_digit_1,uint8_t frac);
void display_lcd_page1(void);
void countdown_reset(void);
void countdown(void);


//*************	main.c	**********************************************
//********************************************************************

extern uint8_t gen_on;				// Variable fr Gert EIN=1 / AUS=0
extern uint8_t ac_period;			// Variable fr Pulslnge Rechteckwechselspg [sec]
extern uint8_t ac_time;				// Zhlvariable fr Pulslnge
extern uint8_t current_mode;		/* Variable fr Spannungsart:
															 current_mode = 1 -> AC
															 current_mode = 0 -> DC */

extern uint32_t voltage_source;				// Variable fr Quellenspannung
extern uint32_t voltage_electrodes;			// Elektroden-Spannung
extern uint32_t current_electrodes;			// Elektroden-Strom

extern char string[];					// Array fr Umwandlung Zahl->String

extern uint8_t M1;						// Merker fr Flankenerkennung
