/***************************************************************************************
*										main.c
*
* WinAVR Vers.:			
*
* AVR-Studio Version:	5
*
* Autor: 				Rick
*
* Getestet:						
*
* Letzte nderung:		
*
***************************************************************************************/



#ifndef UART_BAUD_RATE
#define UART_BAUD_RATE	9600					// Baudrate fr UART
#endif

#ifndef XTAL
#define XTAL 16000000L							// Quarzfrequenz fr Berechnung in Herz
#endif

#ifndef F_CPU
#define F_CPU 16000000L							// Quarzfrequenz fr delay library
#endif

#include "global.h"


#include <avr/io.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/interrupt.h>

/************************** globale Variablen ***************************************/


uint8_t gen_on = 0;					// Variable fr Gert EIN=1 / AUS=0
uint8_t ac_period = 1;				// Variable fr Pulslnge Rechteckwechselspg [sec]
uint8_t ac_time = 0;				// Zhlvariable fr Pulslnge
uint8_t current_mode = 0;			/* Variable fr Spannungsart:
															 current_mode = 1 -> AC
															 current_mode = 0 -> DC */
uint8_t M1,M2;							// Merker fr Flankenerkennung


uint32_t voltage_source = 0;		// Variable fr Quellenspannung
uint32_t voltage_electrodes = 0;	// Elektroden-Spannung
uint32_t current_electrodes = 0;	// Elektroden-Strom

char string[11];					// Array fr Konvertirung in ASCII



//*********************** Ausgnge ***************************************************

#define PORT_MAIN_SWITCH	PORTC				// Hauptschalter fr Generator
#define PIN_MAIN_SWITCH		PC0

#define PORT_AC_SWITCH		PORTC				// Ausgang fr Polarittswechsel
#define PIN_AC_SWITCH		PC6

#define PORT_GREEN_LED		PORTC				// Ausgang fr grne LED
#define PIN_GREEN_LED		PC7

#define PORT_RED_LED		PORTC				// Ausgang fr rote LED
#define PIN_RED_LED			PC3



// ********************************** MAIN *******************************************
//************************************************************************************
int main(void)
{
    
	adc_init();
	timer1_init();
	lcd_init(LCD_DISP_ON);
	countdown_reset();
	//uart_init(UART_BAUD_SELECT(UART_BAUD_RATE,XTAL));
		
	//MCUCSR |= (1<<JTD);		// JTAG aus
	//MCUCSR |= (1<<JTD);
	
	DDRA = 0x00;		// PORTA Pin0 bis 3 fr Testzwecke nicht bentzt ->als Eingang + Pull Up EIN
	PORTA = 0x00;		// High-Z fr ADC
	//PORTA |= (1<<PA0) | (1<<PA1) | (1<<PA2) | (1<<PA3);//| (1<<PA4) | (1<<PA5) | (1<<PA6);
	//PORTA &= ~( (1<<PA4) | (1<<PA5) | (1<<PA6) | (1<<PA7) ); // PA4 bis PA7 fr ADC auf high-z


	DDRC = 0xFF;		// PORTC als Ausgang (LEDs)
	PORTC = 0x00;		// Alle LEDs ein (fr Funktionstest)
	
	DDRD=0x00;
	PORTD=0xFF;
	//DDRD |= (1<<PD2) | (1<<PD3) | (1<<PD4) | (1<<PD5)| (1<<PD6) | (1<<PD7);		// PORTD Pin 2 bis Pin7 als Eingang ,da unbentzt
	//PORTD |= (1<<PD2) | (1<<PD3) | (1<<PD4) | (1<<PD5)| (1<<PD6) | (1<<PD7);	// Interne Pull-Up ein
																				// PD0 + PD1 fr RS232
	for(uint8_t i=0 ; i<= 100 ; i++)  // 1sec warten
		_delay_ms(10);
	
	PORTC = 0xFF;		// Alle LEDs aus
	
	sei();				// globale Interrupts ein
	
	
	/*
	adc_value[2]=100;	// Fr Testzwecke ADC-Wert fr Quellenspg.
	adc_value[3]=1000;	// Elektrodenspg
	adc_value[4]=100;	// Elektrodenstrom
	*/
	
		
//********************************* HAUPTSCHLEIFE *************************************	
//*************************************************************************************
	while(1)		
    {
		
		
// Jede Sekunde nur 1x:
		
		if(time_puls == 1  && !M1)	// wenn Time-Puls=1 und Merker nicht gesetzt	
		{	
			M1=1;					// Merker setzen -> Schleife nur 1x durchlaufen
			//M2=0;
			PORT_GREEN_LED ^= (1<<PIN_GREEN_LED);	// Grne LED als Sekundenanzeige			
			
			if(gen_on == 1)			// wenn Gert eingeschaltet **********************
			{	
				countdown();		// Countdown aktiv
								
				if(current_mode == 1)	// wenn AC-Modus aktiv **********
				{
					ac_time++;			// Zhler fr AC-Modus erhhen
				
					if(ac_time == ac_period) // Bei Gleicheit, AC-Ausgang togglen und 
					{											// Zhler zurcksetzen
						PORT_AC_SWITCH ^= (1<<PIN_AC_SWITCH);	// AC-Ausgang toggeln
						ac_time = 0;							// Zhler rcksetzen
					}
				}				
			}			
		}		
		
//********************************		
		
		if(time_puls == 0)		
			M1=0;					// Merker rcksetzen

//*******************************		
		
		lcd_gotoxy(0,2);							// ADC-Wert fr Tasten anzeigen
		lcd_puts("ADC7:");
		utoa (adc_value[1] , string , 10);
		lcd_puts(string);
		if (adc_value[1] < 100)
			lcd_putc(' ');
		if (adc_value[1] < 10)
			lcd_puts("  ");
		
				
		lcd_gotoxy(10,2);							// Variable equal_counter anzeigen
		utoa (equal_counter , string , 10);
		lcd_puts(string);
		if (equal_counter < 100)
			lcd_putc(' ');
		if (equal_counter < 10)
			lcd_puts("  ");
		
		
		
		
		
		//***************************** TASTENABFRAGE *********************************
		 
		
		switch (button)					// Handlung zuweisen
		{
							
			case 0:						// keine Taste gedrckt nix machen
				break;					
		
			case 1:						// Taste 1
				lcd_gotoxy(0,3);
				lcd_puts("Taste1");						
				
				//PORTC ^= (1<<PC0);
				
				if(gen_on == 0)			// Gert ein- bzw. ausschalten
					gen_on = 1;
				else
					gen_on = 0;
				
				button = 0;				// erkannte Taste zurcksetzen
				break;
						
					 
			case 2:
				lcd_gotoxy(0,3);
				lcd_puts("Taste2");		// Taste 2
								
				if(gen_on == 1) break;	// keine Verstellmglichkeit bei eingesch. Gert
			
				//PORTC ^= (1<<PC1);
			
				if(++hour_countdown >= 11)	// pro Tastendruck +1 Stunde, 
					hour_countdown = 0;		// bei 11h auf 0 zurcksetzen
				
				button = 0;				// erkannte Taste zurcksetzen
				break;
		
			case 3:	
				lcd_gotoxy(0,3);
				lcd_puts("Taste3");		// Taste 3
								
				if(gen_on == 1) break;	// keine Verstellmglichkeit bei eingesch. Gert
			
				//PORTC ^= (1<<PC2);
				
				minute_countdown += 10;		// pro Tastendruck +10min
				if(minute_countdown >= 60)	// werden 60min erreicht, auf 0min zurck
					minute_countdown = 0;
				
				button = 0;				// erkannte Taste zurcksetzen
				break;
		
			case 4:	
				lcd_gotoxy(0,3);
				lcd_puts("Taste4");		// Taste 4
								
				if(gen_on == 1) break;	// keine Verstellmglichkeit bei eingesch. Gert
				
				//PORTC ^= (1<<PC3);
				
				if(++ac_period == 31)		// AC-Puls-Periode, pro Tastendruck +1sec
					ac_period = 1;			// bei 31sec auf 1sec zurcksetzen
				
				button = 0;				// erkannte Taste zurcksetzen
				break;
		
			case 5:	
				lcd_gotoxy(0,3);
				lcd_puts("Taste5");		// Taste 5
								
				if(gen_on == 1) break;	// keine Verstellmglichkeit bei eingesch. Gert
				
				//PORTC ^= (1<<PC4);
				
				if(current_mode == 0)		// Strom-Modus, AC oder DC
					current_mode = 1;		// AC-Modus
				else
					current_mode = 0;		// DC-Modus
				
				button = 0;				// erkannte Taste zurcksetzen
				break;
		
			default:
				break;
		}			
													
		
		
		
		
		//************************ AUSGNGE SETZEN *************************************
		
		//******** Gert AUS
		
		if(gen_on == 0)
		{
			//PORTC |= (1<<PC0);		// LED0 aus
			
			PORT_MAIN_SWITCH &= ~(1<<PIN_MAIN_SWITCH);		// Gert ausschalten
			
			PORT_AC_SWITCH &= ~(1<<PIN_AC_SWITCH);	// AC Ausgang auf 0
			ac_time = 0;							// Zhler fr AC_mode zurcksetzen
		}
		
		//******** Gert EIN *** 
		
		if( gen_on == 1 )			// Gert EIN
		{
			//PORTC &= ~(1<<PC0);		// LED0 ein
			
			PORT_MAIN_SWITCH |= (1<<PIN_MAIN_SWITCH);		// Gert EIN
			
		}		
		
		
		//************************* Messwerte Berechnen ***********************
		
			
			//read_voltage_source();
			read_voltage_electrodes();
			read_current_electrodes();
				
		
				
		//************************** DISPLAY AUSGABE ***************************
		
		
		display_lcd_page1();		// Anzeigeseite 1 am LCD ausgeben
		/*
		if(time_puls == 0 && !M2)
		{
			M2=1;
			display_lcd_page1();		// Anzeigeseite 1 am LCD ausgeben
		}		
		*/
				
		
	    
	}    // Ende While-Schleife

}	// Ende Main
